import { world, Vector } from "@minecraft/server";
import { getScore } from "../functions";
world.afterEvents.effectAdd.subscribe(data => {
  if (data.entity.typeId == "blayy:coal_generator") {
    const trancedi = data.entity
    const tags = trancedi.getTags();
  let inv = trancedi.getComponent("minecraft:inventory").container
  let slots = [0, 1, 2, 3]
slots.forEach(slot=>{
  const item = inv.getItem(slot)
  if(item){
    if (item.typeId == "minecraft:coal" || "minecraft:charcoal") {
      if (item.amount >= 2) {
    trancedi.runCommandAsync(`replaceitem entity @s slot.inventory ${slot} minecraft:coal ${item.amount-1}`)
    
    trancedi.runCommandAsync(`scoreboard players add @e[type=blayy:energy_cube,tag="${tags[0]}"] energy 1`)
      }
      else if (item.amount == 1) {
        trancedi.runCommandAsync(`scoreboard players add @e[type=blayy:energy_cube,tag="${tags[0]}"] energy 1`)
        trancedi.runCommandAsync(`replaceitem entity @s slot.inventory ${slot} air`)
      }else{
        trancedi.runCommandAsync(`setblock ~~~ air 0 destroy`)
      }
      
    }else{
      trancedi.runCommandAsync(`setblock ~~~ air 0 destroy`)
      trancedi.runCommandAsync(`say the carbon generator only supports coals`)
    }
  }
 
})
  }
  if (data.entity.typeId == "blayy:energy") {
    const tags = data.entity.getTags()
    const entity = data.entity
    const escore = getScore("energy", entity)
    
    if (escore != 6) {
      
   data.entity.runCommandAsync(`execute as @s if entity @e[type=blayy:energy_cube,tag="${tags[0]}",scores={energy=1..}] run scoreboard players add @s energy 1`)
   
   data.entity.runCommandAsync(`execute if entity @e[type=blayy:energy_cube,tag="${tags[0]}",scores={energy=1..}] run scoreboard players remove @e[type=blayy:energy_cube,tag="${tags[0]}",scores={energy=1..}] energy 1`)
    }
}
if (data.entity.typeId == "blayy:quarrye") {
  const name = data.entity.nameTag
  data.entity.runCommandAsync(`scoreboard players set @s atraso0 0`)
data.entity.runCommandAsync(`execute unless entity @e[type=blayy:quarrye1,name="${name}"] run summon blayy:quarrye1 "${name}" ~~~`)
data.entity.runCommandAsync(`tp @e[type=item,r=5] ~~2~`)
}
if (data.entity.typeId == "blayy:quarrye1") {
  const nome = data.entity.nameTag
data.entity.runCommandAsync(`tp @e[type=item,r=10] @e[type=blayy:quarrye,name="${nome}"]`)
data.entity.runCommandAsync(`execute as @s unless entity @e[type=blayy:quarrye,name="${nome}"] run kill @s[type=blayy:quarrye1]`)
}

})