import { world, system, Vector } from "@minecraft/server";
import { ActionFormData, MessageFormData, ModalFormData } from "@minecraft/server-ui";
import { getScore } from "../functions";
world.beforeEvents.itemUseOn.subscribe(data => {
    let block = data.block
    let x = block.location.x
    let y = block.location.y
    let z = block.location.z
    const player = data.source
  const itemdata = player.getComponent("inventory").container.getItem(player.selectedSlot)
  if (itemdata.typeId == "blayy:energy_cube") {
    system.run((run) => { 
    const code = new ModalFormData()
code.title(`code.energy_cube`)
code.textField(`code.energy_cube.field`, `escreva.aqui`, "")
code.textField(`code.energy_cube.field1`, `escreva.aqui`, "")

  code.show(player).then(response => {
    const id = Math.floor(Math.random() * 9999999999999).toString(36)
     if (response.formValues[1] != "") {
       player.runCommandAsync(`execute unless entity @e[tag="${id}",name="§l§b${response.formValues[0]} (Private) | ${player.nameTag}"] run summon blayy:energy_cube "§l§b${response.formValues[0]} (Private) | ${player.nameTag}" ${x} ${y+1} ${z}`)
       player.runCommandAsync(`scoreboard players set @e[type=blayy:energy_cube,name="§l§b${response.formValues[0]} (Private) | ${player.nameTag}"] energy 0`)
       player.runCommandAsync(`scoreboard players set @e[type=blayy:energy_cube,name="§l§b${response.formValues[0]} (Private) | ${player.nameTag}"] max_energy 99999`)
       player.runCommandAsync(`tag  @e[type=blayy:energy_cube,name="§l§b${response.formValues[0]} (Private) | ${player.nameTag}"] add "${id}"`)
       player.runCommandAsync(`tag  @e[type=blayy:energy_cube,name="§l§b${response.formValues[0]} (Private) | ${player.nameTag}"] add "pass_${response.formValues[1]}"`)
       player.runCommandAsync(`tag @s add "${id}"`)
       player.runCommandAsync(`clear @s blayy:energy_cube`)
     }else{
      player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"erro.field"}]}`)
     } 
  })
    })
 }
if (itemdata.typeId == "blayy:energy_card") {
    const player = data.source
     const item = itemdata
     const random = Math.floor(Math.random() * 9999)
     let lore = item.getLore()
     if ((`${lore}`) != "") {
     if (player.hasTag(`${lore}`) || entity.hasTag("public") == true) {
     player.runCommandAsync(`execute if block ${x} ${y} ${z} blayy:energy_block run summon blayy:energy "${lore} | ${random}" ${x} ${y} ${z}`)
     player.runCommandAsync(`execute if block ${x} ${y} ${z} blayy:energy_block run particle blayy:conectado ${x} ${y+1.25} ${z}`)
     
     player.runCommandAsync(`execute if block ${x} ${y} ${z} blayy:carbon_generator run summon blayy:coal_generator "${lore} | ${random}" ${x} ${y} ${z}`)
     player.runCommandAsync(`execute if block ${x} ${y} ${z} blayy:carbon_generator run particle blayy:conectado ${x} ${y+1.25} ${z}`)
     
     player.runCommandAsync(`execute if block ${x} ${y} ${z} blayy:geothermal_generator run summon blayy:thermal_entity "${lore} | ${random}" ${x} ${y} ${z}`)
     player.runCommandAsync(`execute if block ${x} ${y} ${z} blayy:geothermal_generator run particle blayy:conectado ${x} ${y+1.25} ${z}`)
     
     player.runCommandAsync(`tag @e[name="${lore} | ${random}"] add "${lore}"`)
     }else{
    const player = data.source
   player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"erro.acesso"}]}`)
  }
}else{
    const player = data.source
   player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"erro.find.conexao"}]}`)
  }
}

})