import { world, Vector } from "@minecraft/server";
import { ActionFormData, MessageFormData, ModalFormData } from "@minecraft/server-ui";
import { getScore } from "../functions";

world.beforeEvents.blockBreak.subscribe(data => {
  if (data.player.getComponent("inventory").container.getItem(data.player.selectedSlot) == "blayy:future_pickaxe") {
    
  }
  if (data.brokenBlockPermutation.type.id.startsWith("blayy:digital_drawer") == true) {
const x = data.block.location.x
const y = data.block.location.y
const z = data.block.location.z
  const overworld = world.getDimension("overworld")
const pegar = new Vector(x, y, z)
const entities = overworld.getEntitiesAtBlockLocation(pegar) 
for (const entity of entities) {
  const playerName = data.player.nameTag
  const entitytags = entity.getTags()
  const score = getScore("storage", entity)
  entity.runCommandAsync(`give @a[name="${playerName}",c=1] ${entitytags[0]} ${score}`)
  entity.runCommandAsync(`kill @s`)
}
}
})