import { world, Vector } from "@minecraft/server";
import { ActionFormData, MessageFormData, ModalFormData } from "@minecraft/server-ui";
import { getScore } from "../functions";

world.afterEvents.entityHit.subscribe(data => {
  if (data.hitEntity.typeId == "blayy:energy_cube") {
  const player = data.entity
  const entity = data.hitEntity
  let energy = getScore("energy", data.hitEntity)
  let energymax = getScore("max_energy", data.hitEntity)
  const tag = entity.getTags()
  const pass = tag[1].replace('pass_', '')
    if ((`${tag[0]}`) != "") {
    if (player.hasTag(`${tag[0]}`) || entity.hasTag("public") == true) {
  const code1 = new ActionFormData()
  code1.title(`${entity.nameTag}`)
  const query = {
  tags: [`${tag[0]}`],
};
if (entity.hasTag("public") == true) {
 code1.body(`§9PF¹: ${energy}/${energymax}\n§2EnergyCube ID: ${tag[0]}\n§fPlayers with access: §5(All Players)\n§3Password: (None)`)
     }else{
  const cus = world.getPlayers(query);
  code1.body(`§9PF¹: ${energy}/${energymax}\n§2ID: ${tag[0]}\n§3Password: ${pass}`)
  
    }
  code1.button(`code1.add_acess`)
  code1.button(`code1.connect_item`)
  code1.button(`code1.destroy_cube`)
  code1.show(player).then(response => {
    if (response.selection == 0) {
      const acesso = new ModalFormData()
      acesso.title(`code1.add_acess`)
      acesso.textField(`text.player.name`, `escreva.aqui`, "")
      
      
     acesso.show(player).then(response => {
       if (response.formValues[0] != "") {
         player.runCommandAsync(`tag @a[name="${response.formValues[0]}"] add "${tag[0]}"`)
         player.runCommandAsync(`execute unless entity @a[name="${response.formValues[0]}"] run tellraw @s {"rawtext":[{"translate":"erro.player"}]}`) 
       }else{
        player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"erro.field"}]}`) 
       }
     })
    }
   if (response.selection == 1) {
    class loreItem {
     constructor(itemId, lore) {
      this.itemId = itemId;
      this.lore = lore;
     }
    }
    const ItemArray = [
     new loreItem("blayy:mobile_device", [`${tag[0]}`]),
     new loreItem("blayy:energy_card", [`${tag[0]}`]),
     new loreItem("blayy:power_stack", [`${tag[0]}`, `0`]),
    ]
    const playerContainer = player.getComponent("inventory").container
    for (let i = 0; i < playerContainer.size; i++) {
     const item = playerContainer.getItem(i)
     const findLore = ItemArray.find(x => x.itemId == item?.typeId)
     const lore = item?.getLore()
     if (!findLore || !item || lore?.length != 0) continue
     item.setLore(findLore.lore)
     playerContainer.setItem(i, item)
    }
    player.runCommandAsync(`tellraw @s[hasitem={location=slot.weapon.mainhand,item=blayy:mobile_device}] {"rawtext":[{"translate":"sucess.conexao"}]}`)
    player.runCommandAsync(`tellraw @s[hasitem={location=slot.weapon.mainhand,item=blayy:energy_card}] {"rawtext":[{"translate":"sucess.conexao"}]}`)
    player.runCommandAsync(`tellraw @s[hasitem={location=slot.weapon.mainhand,item=blayy:power_stack}] {"rawtext":[{"translate":"sucess.conexao"}]}`)
    player.runCommandAsync(`execute unless entity @s[hasitem={location=slot.weapon.mainhand,item=blayy:energy_card}] unless entity @s[hasitem={location=slot.weapon.mainhand,item=blayy:mobile_device}] unless entity @s[hasitem={location=slot.weapon.mainhand,item=blayy:power_stack}] run tellraw @s {"rawtext":[{"translate":"erro.conexao"}]}`)
   }
   if (response.selection == 2) {
     entity.runCommandAsync(`kill @s`)
     entity.runCommandAsync(`tag @a remove "${tag[0]}`)
   }
  })
 }else{
   const acessar = new ModalFormData()
   acessar.title(`code.get_acess`)
   acessar.textField(`code.get_acess_text`, `escreva.aqui`, "")
   acessar.show(player).then(response => {
     if (response.formValues[0] != "") {
       if (response.formValues[0] == `${pass}`) {
         player.runCommandAsync(`tag @s add ${tag[0]}`)
       }else{
       player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"erro.senha"}]}`)
     }
     }else{
       player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"erro.field"}]}`)
     }
   })
 }
  }else{
    player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"erro.find.conexao"}]}`)
  }
}
})