import { world, Vector, ItemStack } from "@minecraft/server";
import { ActionFormData, MessageFormData, ModalFormData } from "@minecraft/server-ui";
import { getScore } from "../functions";

world.afterEvents.itemUse.subscribe(data => {
  const data_item = data.source.getComponent("inventory").container.getItem(data.source.selectedSlot)  
  if (data_item.typeId == "blayy:mobile_device") {
  if (data_item.getLore() != "") {
  const player = data.source
  const lore = data_item.getLore()
  const query = {
  type: "blayy:energy_cube",
  tags: [`${lore}`],
};
const overworld = world.getDimension("overworld")
const pintos = overworld.getEntities(query);
for (const pinto of pintos) {
  if (player.hasTag(`${lore}`) || pinto.hasTag("public") == true) {
  const cu = getScore("energy", pinto)
  const cuz = getScore("max_energy", pinto)
  const cont = player.getComponent("inventory").container
  const cell = new ActionFormData()
  cell.title(`item.blayy:mobile_device.name`)
  cell.body(`§9PF: ${cu}/${cuz}\n§2ID: ${lore}`)
  cell.button(`cell.gift_item`)
  cell.button(`cell.sendmsg`)
  cell.button(`cell.tpcube`)
  cell.button(`code1.destroy_cube`)
  const sele = new ActionFormData()
  sele.title(`cell.gift_item`)
  sele.body(`sele.select_hotbar`)
  let item = cont.getItem(0)
  if(item){
    let text = item.typeId.split(":")[1]
    sele.button(item.typeId, `textures/items/${text}`)
  }
  let item1 = cont.getItem(1)
  if(item1){
    let text = item1.typeId.split(":")[1]
    sele.button(item1.typeId, `textures/items/${text}`)
  }
  let item2 = cont.getItem(2)
  if(item2){
    let text = item2.typeId.split(":")[1]
    sele.button(item2.typeId, `textures/items/${text}`)
  }
  let item3 = cont.getItem(3)
  if(item3){
    let text = item3.typeId.split(":")[1]
    sele.button(item3.typeId, `textures/items/${text}`)
  }
  let item4 = cont.getItem(4)
  if(item4){
    let text = item4.typeId.split(":")[1]
    sele.button(item4.typeId, `textures/items/${text}`)
  }
  let item5 = cont.getItem(5)
  if(item5){
    let text = item5.typeId.split(":")[1]
    sele.button(item5.typeId, `textures/items/${text}`)
  }
  let item6 = cont.getItem(6)
  if(item6){
    let text = item6.typeId.split(":")[1]
    sele.button(item6.typeId, `textures/items/${text}`)
  }
  let item7 = cont.getItem(7)
  if(item7){
    let text = item7.typeId.split(":")[1]
    sele.button(item7.typeId, `textures/items/${text}`)
  }
  let item8 = cont.getItem(8)
  if(item8){
    let text = item8.typeId.split(":")[1]
    sele.button(item8.typeId, `textures/items/${text}`)
  }
  const gift = new ModalFormData() 
      gift.title(`cell.gift_item`)
      const casas = world.getPlayers();
     for (const casa of casas) {
      gift.textField(`text.player.name`, `escreva.aqui`, "")
     }
  cell.show(player).then(response => {
    if (response.selection == 0) {
      if (cu >= 10) {
      sele.show(player).then(rola => {
        let selec = rola.selection
        if (selec == 0) {
          gift.slider(`text.item.amount`, 1, cont.getItem(0).amount, 1)
        }
        if (selec == 1) {
          gift.slider(`text.item.amount`, 1, cont.getItem(1).amount, 1)
        }
        if (selec == 2) {
          gift.slider(`text.item.amount`, 1, cont.getItem(2).amount, 1)
        }
        if (selec == 3) {
          gift.slider(`text.item.amount`, 1, cont.getItem(3).amount, 1)
        }
        if (selec == 4) {
          gift.slider(`text.item.amount`, 1, cont.getItem(4).amount, 1)
        }
        if (selec == 5) {
          gift.slider(`text.item.amount`, 1, cont.getItem(5).amount, 1)
        }
        if (selec == 6) {
          gift.slider(`text.item.amount`, 1, cont.getItem(6).amount, 1)
        }
        if (selec == 7) {
          gift.slider(`text.item.amount`, 1, cont.getItem(7).amount, 1)
        }
        if (selec == 8) {
          gift.slider(`text.item.amount`, 1, cont.getItem(8).amount, 1)
        }
        gift.show(player).then(cuu => {
        if(cuu.formValues[0] != "") {
         if (selec == 0) {
          player.runCommandAsync(`execute as @s[hasitem={location=slot.hotbar,item=${cont.getItem(0).typeId},quantity=${cuu.formValues[1]}..}] run give "${cuu.formValues[0]}" ${cont.getItem(0).typeId} ${cuu.formValues[1]} 0`)
          player.runCommandAsync(`execute as @s[hasitem={location=slot.hotbar,item=${cont.getItem(0).typeId},quantity=${cuu.formValues[1]}..}] run scoreboard players remove @e[tag="${lore}"] energy 10`)
          player.runCommandAsync(`clear @s ${cont.getItem(0).typeId} 0 ${cuu.formValues[1]}`)
        }
        if (selec == 1) {
          player.runCommandAsync(`execute as @s[hasitem={location=slot.hotbar,item=${cont.getItem(1).typeId},quantity=${cuu.formValues[1]}..}] run give "${cuu.formValues[0]}" ${cont.getItem(1).typeId} ${cuu.formValues[1]} ${cont.getItem(1).data}`)
          player.runCommandAsync(`execute as @s[hasitem={location=slot.hotbar,item=${cont.getItem(1).typeId},quantity=${cuu.formValues[1]}..}] run scoreboard players remove @e[tag="${lore}"] energy 10`)
          player.runCommandAsync(`clear @s ${cont.getItem(1).typeId} ${cont.getItem(1).data} ${cuu.formValues[1]}`)
        }
        if (selec == 2) {
          player.runCommandAsync(`execute as @s[hasitem={location=slot.hotbar,item=${cont.getItem(2).typeId},quantity=${cuu.formValues[1]}..}] run give "${cuu.formValues[0]}" ${cont.getItem(2).typeId} ${cuu.formValues[1]} ${cont.getItem(2).data}`)
          player.runCommandAsync(`execute as @s[hasitem={location=slot.hotbar,item=${cont.getItem(2).typeId},quantity=${cuu.formValues[1]}..}] run scoreboard players remove @e[tag="${lore}"] energy 10`)
          player.runCommandAsync(`clear @s ${cont.getItem(2).typeId} ${cont.getItem(2).data} ${cuu.formValues[1]}`)
        }
        if (selec == 3) {
          player.runCommandAsync(`execute as @s[hasitem={location=slot.hotbar,item=${cont.getItem(3).typeId},quantity=${cuu.formValues[1]}..}] run give "${cuu.formValues[0]}" ${cont.getItem(3).typeId} ${cuu.formValues[1]} ${cont.getItem(3).data}`)
          player.runCommandAsync(`execute as @s[hasitem={location=slot.hotbar,item=${cont.getItem(3).typeId},quantity=${cuu.formValues[1]}..}] run scoreboard players remove @e[tag="${lore}"] energy 10`)
          player.runCommandAsync(`clear @s ${cont.getItem(3).typeId} ${cont.getItem(3).data} ${cuu.formValues[1]}`)
        }
        if (selec == 4) {
          player.runCommandAsync(`execute as @s[hasitem={location=slot.hotbar,item=${cont.getItem(4).typeId},quantity=${cuu.formValues[1]}..}] run give "${cuu.formValues[0]}" ${cont.getItem(4).typeId} ${cuu.formValues[1]} ${cont.getItem(4).data}`)
          player.runCommandAsync(`execute as @s[hasitem={location=slot.hotbar,item=${cont.getItem(4).typeId},quantity=${cuu.formValues[1]}..}] run scoreboard players remove @e[tag="${lore}"] energy 10`)
          player.runCommandAsync(`clear @s ${cont.getItem(4).typeId} ${cont.getItem(4).data} ${cuu.formValues[1]}`)
        }
        if (selec == 5) {
          player.runCommandAsync(`execute as @s[hasitem={location=slot.hotbar,item=${cont.getItem(5).typeId},quantity=${cuu.formValues[1]}..}] run give "${cuu.formValues[0]}" ${cont.getItem(5).typeId} ${cuu.formValues[1]} ${cont.getItem(5).data}`)
          player.runCommandAsync(`execute as @s[hasitem={location=slot.hotbar,item=${cont.getItem(5).typeId},quantity=${cuu.formValues[1]}..}] run scoreboard players remove @e[tag="${lore}"] energy 10`)
          player.runCommandAsync(`clear @s ${cont.getItem(5).typeId} ${cont.getItem(5).data} ${cuu.formValues[1]}`)
        }
        if (selec == 6) {
          player.runCommandAsync(`execute as @s[hasitem={location=slot.hotbar,item=${cont.getItem(6).typeId},quantity=${cuu.formValues[1]}..}] run give "${cuu.formValues[0]}" ${cont.getItem(6).typeId} ${cuu.formValues[1]} ${cont.getItem(6).data}`)
          player.runCommandAsync(`execute as @s[hasitem={location=slot.hotbar,item=${cont.getItem(6).typeId},quantity=${cuu.formValues[1]}..}] run scoreboard players remove @e[tag="${lore}"] energy 10`)
          player.runCommandAsync(`clear @s ${cont.getItem(6).typeId} ${cont.getItem(6).data} ${cuu.formValues[1]}`)
        }
        if (selec == 7) {
          player.runCommandAsync(`execute as @s[hasitem={location=slot.hotbar,item=${cont.getItem(7).typeId},quantity=${cuu.formValues[1]}..}] run give "${cuu.formValues[0]}" ${cont.getItem(7).typeId} ${cuu.formValues[1]} ${cont.getItem(7).data}`)
          player.runCommandAsync(`execute as @s[hasitem={location=slot.hotbar,item=${cont.getItem(7).typeId},quantity=${cuu.formValues[1]}..}] run scoreboard players remove @e[tag="${lore}"] energy 10`)
          player.runCommandAsync(`clear @s ${cont.getItem(7).typeId} ${cont.getItem(7).data} ${cuu.formValues[1]}`)
        }
        if (selec == 8) {
          player.runCommandAsync(`execute as @s[hasitem={location=slot.hotbar,item=${cont.getItem(8).typeId},quantity=${cuu.formValues[1]}..}] run give "${cuu.formValues[0]}" ${cont.getItem(8).typeId} ${cuu.formValues[1]} ${cont.getItem(8).data}`)
          player.runCommandAsync(`execute as @s[hasitem={location=slot.hotbar,item=${cont.getItem(8).typeId},quantity=${cuu.formValues[1]}..}] run scoreboard players remove @e[tag="${lore}"] energy 10`)
          player.runCommandAsync(`clear @s ${cont.getItem(8).typeId} ${cont.getItem(8).data} ${cuu.formValues[1]}`)
        }
        }else{
          player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"erro.field"}]}`)
        }
      })
      })
      }
    }
    if (response.selection == 1) {
      if (cu >= 1) {
     const name = new ModalFormData()
     name.title(`cell.sendmsg`)
     const casas = world.getPlayers();
     for (const casa of casas) {
     name.textField(`text.player.name`, `escreva.aqui`, "")
     }
     name.textField(`text.message`, `escreva.aqui`, "")
     name.show(player).then(response => {
       if(response.formValues[0] != "" && response.formValues[1] != "") {
         player.runCommandAsync(`execute if entity @a[name="${response.formValues[0]}"] run scoreboard players remove @e[tag="${lore}"] energy 1`)
         player.runCommandAsync(`execute unless entity @a[name="${response.formValues[0]}"] run tellraw @s {"rawtext":[{"translate":"erro.player"}]}`)
       player.runCommandAsync(`tellraw @a[name="${response.formValues[0]}"] {"rawtext":[{"text":"${response.formValues[1]}§9§l - By ${player.nameTag}"}]}`)
       }
     })
      }
    }
    if (response.selection == 2) {
      if (cu >= 5) {
        player.runCommandAsync(`scoreboard players remove @e[tag="${lore}"] energy 5`)
      player.runCommandAsync(`tp @e[type=blayy:energy_cube,tag="${lore}"] @s`)
      }else{
        
      }
    }
    if (response.selection == 3) {
      player.runCommandAsync(`kill @e[tag="${lore}"]`)
    }
  })
  }
  }
  if (player.hasTag(`${lore}`) != true && pinto.hasTag("public") != true) {
    const player = data.source
   player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"erro.acesso"}]}`)
  }
  
 }else{
   const player = data.source
   player.runCommandAsync(`tellraw @s {"rawtext":[{"translate":"erro.find.conexao"}]}`)
 }
}
if (data_item.typeId == "blayy:power_stack") {
    const player = data.source
  const lorea = data_item.getLore()
  
  const query = {
  type: "blayy:energy_cube",
  tags: [`${lorea[0]}`],
};
const overworld = world.getDimension("overworld")
const paus = overworld.getEntities(query);
for (const pau of paus) {
  const score = getScore("energy", pau)
  const scoremax = getScore("max_energy", pau)
  const stack = new ModalFormData()
  stack.title(`Power Stack`)
  stack.textField(`${score}/${scoremax}`, `escreva.aqui`, "")
  stack.show(player).then(response => {
    if (response.formValues[0] <= score) {
class loreItem {
     constructor(itemId, lore) {
      this.itemId = itemId;
      this.lore = lore;
     }
    }

const rodaIsso = () => {
    const ItemArray = [
     new loreItem("blayy:power_stack", [`${lorea[0]}`, `${response.formValues[0] + lorea[1].split("/")[0]}/5000`]),
    ]
    const playerContainer = player.getComponent("inventory").container
    for (let i = 0; i < playerContainer.size; i++) {
     const item = playerContainer.getItem(i)
     const findLore = ItemArray.find(x => x.itemId == item?.typeId)
     const lore = item?.getLore()
     if (!findLore || !item || lore?.length != 0) {}
     else {
item.setLore(findLore.lore)
     playerContainer.setItem(i, item)
}
    }
}; rodaIsso()
    }
  })
  
}

}
if (data_item.typeId == "minecraft:diamond_sword") {
  data.source.runCommandAsync("say oi")
  
 
}
})