import { world } from "@minecraft/server";
export function getScore(objective, target, useZero = false) {
    try {
        const score = world.scoreboard.getObjective(objective)
        if (typeof target == 'string') return score.getScore(score.getParticipants().find(part => part.displayName == target))
        return score.getScore(target.scoreboardIdentity)
    } catch {
        return useZero ? 0 : NaN
    }
}